;************************************************************************************************************************************
; ROMTable.inc : Header file for ROM lookup table code																				*
;************************************************************************************************************************************

#ifndef __ROMTABLE_INC__
#define __ROMTABLE_INC__

;************************************************************************************************************************************
; Equ's and Defines																													*
;************************************************************************************************************************************

;...Add Equ's and Defines here...

;************************************************************************************************************************************
; Imports																															*
;************************************************************************************************************************************

	;Registers
	EXTERN	ROMTableAddr			;Low byte of ROM pointer
	EXTERN	ROMTableAddrH			;High byte of ROM pointer

	;Functions
	EXTERN	ROMTableGet				;Returns the ROMTable byte pointed to by the pointer in W, increments pointer  (X, X)

;************************************************************************************************************************************
; Macros																															*
;************************************************************************************************************************************
; ROMTableSetPtr: Sets the ROMTable code's pointer to "Address"																		*
;				  Entry -> Bank X																									*
;				  Exit  -> Bank X																									*
;************************************************************************************************************************************
ROMTableSetPtr				Macro	Address

	BANKSEL	ROMTableAddr			;Bank "PointerBank"
	MOVLW	LOW(Address)
	MOVWF	ROMTableAddr			;Copy low byte of ROM address to pointer
	MOVLW	HIGH(Address)
	MOVWF	ROMTableAddrH			;Copy High byte of ROM address to pointer

	Endm

;************************************************************************************************************************************
; ROMTableSetPrtOffsetW : Sets the ROMTable code's pointer to "Address" + W															*
;						  Entry -> Bank X																							*
;						  Exit  -> Bank X																							*
;************************************************************************************************************************************
ROMTableSetPtrOffsetW		Macro	Address

	BANKSEL	ROMTableAddr			;Bank "PointerBank"
	MOVWF	ROMTableAddr			;Store offset to low byte of pointer
	MOVLW	LOW(Address)
	ADDWF	ROMTableAddr, F			;And add the low byte of the ROM address to it - **
	MOVLW	HIGH(Address)			;Copy High byte of ROM address to W
	BTFSC	STATUS, C				; - ** Carry ? 
	ADDLW	0x01					;Yes? Then add 1 to high byte of ROM address
	MOVWF	ROMTableAddrH			;And store

	Endm

;************************************************************************************************************************************
 
#endif __ROMTABLE_INC__
